<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Building Dynamic Gemini Capsules with Go!</title>
<meta name="author" content="dt" />
<meta name="description" content="Guest Articles - Building Dynamic Gemini Capsules with Go!
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Building Dynamic Gemini Capsules with Go!</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#orgbcc3072">Building Dynamic Gemini Capsules with Go!</a></li>
<li><a href="#org749b1dc">Requirements</a>
<ul>
<li><a href="#orgbaee4f6">Software:</a></li>
<li><a href="#org648d8bf">Go packages:</a></li>
</ul>
</li>
<li><a href="#orgcc6535c">Setting Up The Project</a></li>
<li><a href="#org4e757af">Let&rsquo;s Write Some Code</a></li>
<li><a href="#orgd1d5872">Conclusion</a></li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="../kb/index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-orgbcc3072" class="outline-2">
<h2 id="orgbcc3072">Building Dynamic Gemini Capsules with Go!</h2>
<div class="outline-text-2" id="text-orgbcc3072">
<p>
<i>By Tre Babcock at May 31, 2021</i>
</p>

<p>
Gemini is, by design, simple. No styles, no scripting, and almost no interactivity. But we can use what little interactivity we&rsquo;re given, links and the input status, along with some serverside scripting to make some interesting content! 
</p>

<p>
In this article, we&rsquo;re going to make a simple textboard with posts and comments. For the sake of simplicity, all posts and comments will be anonymous.
</p>
</div>
</div>

<div id="outline-container-org749b1dc" class="outline-2">
<h2 id="org749b1dc">Requirements</h2>
<div class="outline-text-2" id="text-org749b1dc">
</div>
<div id="outline-container-orgbaee4f6" class="outline-3">
<h3 id="orgbaee4f6">Software:</h3>
<div class="outline-text-3" id="text-orgbaee4f6">
<ul class="org-ul">
<li>Go 1.14+</li>
</ul>
</div>
</div>
<div id="outline-container-org648d8bf" class="outline-3">
<h3 id="org648d8bf">Go packages:</h3>
<div class="outline-text-3" id="text-org648d8bf">
<ul class="org-ul">
<li>github.com/google/uuid v1.2.0</li>
<li>github.com/pitr/gig v0.9.8</li>
<li>gorm.io/driver/sqlite v1.1.4</li>
<li>gorm.io/gorm v1.21.10</li>
</ul>
</div>
</div>
</div>

<div id="outline-container-orgcc6535c" class="outline-2">
<h2 id="orgcc6535c">Setting Up The Project</h2>
<div class="outline-text-2" id="text-orgcc6535c">
<pre class="example" id="orgc5728c8">
mkdir textboard
cd textboard/
go mod init textboard
</pre>

<p>
This will create our project folder, and initialize a Go module.
</p>
<pre class="example" id="orgd9074a6">
mkdir app/
mkdir app/handler
mkdir app/model
touch main.go
touch app/app.go
touch app/handler/posts.go
touch app/model/post.go
touch app/model/model.go
</pre>

<p>
I know this seems unnecessarily complicated, but it&rsquo;s a good project structure that will help the project scale.
</p>
</div>
</div>

<div id="outline-container-org4e757af" class="outline-2">
<h2 id="org4e757af">Let&rsquo;s Write Some Code</h2>
<div class="outline-text-2" id="text-org4e757af">
<p>
Let&rsquo;s start with app/model/post.go to set up the models.
</p>

<pre class="example" id="org7dc8fdf">
package model

// Post is our post model
type Post struct {
    Content     string      // the post's contents
    ID          string      // the post's ID (a UUID)
    Time        string      // the post's creation time
    Comments    []Comment   // the post's comments
}

type Comment struct {
    Content     string      // the comment's contents
    ID          string      // the comment's ID (also a UUID)
    Time        string      // the comment's creation time
    PostID      string      // the ID of the post for this comment
}
</pre>

<p>
That&rsquo;s all for this file. Next let&rsquo;s open up app/model/model.go to setup the database migration function.
</p>

<pre class="example" id="org37542ad">
package model

import (
    _ "gorm.io/driver/sqlite"
    "gorm.io/gorm"
)

// DBMigrate will setup the database tables for the specified models and return a database object
func DBMigrate(db *gorm.DB) *gorm.DB {
    db.AutoMigrate(&amp;Post{}, &amp;Comment{})
    return db
}
</pre>

<p>
This file is also done now. Now we can open up app/app.go and setup our app!
</p>

<pre class="example" id="orgf4cc34a">
package app

import (
    "fmt"
    "log"
    "textboard/app/model"
    "textboard/app/handler"
    
    "github.com/pitr/gig" 
    "gorm.io/driver/sqlite"
    "gorm.io/gorm"
)

// App holds our router and database
type App struct {
    Router  *gig.Gig
    DB      *gorm.DB
}

// baseURL is a helper function to return the full url of a path
func baseURL(route string) string {
    return fmt.Sprintf("gemini://localhost%s", route)
}

func (a *App) Init() {
    // Open the database, or create it if it doesn't exist
    db, err := gorm.Open(sqlite.Open("gorm.db"), &amp;gorm.Config{})
    if err != nil {
        log.Fatal(err)
    }
    a.DB = model.DBMigrate(db)
    a.Router = gig.Default()
    
    a.setRoutes() // we'll get to this soon
}
</pre>

<p>
Now that we have a basic server setup, we can begin adding dynamic routes. Let&rsquo;s think for a minute about what routes we&rsquo;ll need. We&rsquo;ll have an index page that will show all the posts. We&rsquo;ll have a post page that shows a specified post and its comments. And then we&rsquo;ll need routes for sending posts and replies. Something like this:
</p>
<ul class="org-ul">
<li>/</li>
<li><i>post</i>:id</li>
<li>/createpost</li>
<li><i>createcomment</i>:postId</li>
</ul>

<p>
Easy enough. Now let&rsquo;s write some more code! Open up app/app.go again.
</p>

<pre class="example" id="org428eef8">
// See, I told you we'd come back to it. This function will setup our routes with a handler function
func (a *App) setRoutes() {
    a.handle("/", a.index)
    a.handle("/post/:id", a.post)
    a.handle("/createpost", a.createPost)
    a.handle("/createcomment/:postId", a.createComment)
}

// This function takes in a route and a handler function, as seen above, then tells gig to handle it
func (a *App) handle(path string, f func(c gig.Context) error) {
    a.Router.Handle(path, f)
}

// Index handler
func (a *App) index(c gig.Context) error {
    
}

// Post handler
func (a *App) post(c gig.Context) error {
    
}

// Create post handler
func (a *App) createPost(c gig.Context) error {
    
}

// Create comment handler
func (a *App) createComment(c gig.Context) error {
    
}
</pre>

<p>
Before we can setup these handlers, we need to write some other handlers! Open up app/handler/posts.go so we can get that out of the way.
</p>

<pre class="example" id="org45bdd0d">
package handler

import (
    "textboard/app/model"
    "time"
    "github.com/google/uuid"
    "gorm.io/gorm"
)

// CreatePost will create a new post and add it to the database, then return the post's ID
func CreatePost(db *gorm.DB, content string) string {
    id := uuid.NewString()
    
    post := model.Post{
        Content: content,
        ID:      id,
        Time:    time.Now().UTC().Format(time.Stamp),
    }
    
    // This bit of code saves the post, and the code in the brackets only runs if there's an error
    if err := db.Create(&amp;post).Error; err != nil {
        return "error"
    }
    return id
}

// GetPost will look in the database for a post with the specified ID, then return that post
func GetPost(db *gorm.DB, id string) *model.Post {
    post := model.Post{}
    if err := db.First(&amp;post, db.Where(model.Post{ID: id})).Error; err != nil {
        return nil
    }
    return &amp;post
}

// GetAllPosts will return all posts from the database
func GetAllPosts(db *gorm.DB) []model.Post {
    posts := []model.Post{}
    db.Find(&amp;posts)
    return posts
}

// AddComment will create a new comment object and then add it to the Comments slice in the specified post
func AddComment(db *gorm.DB, content, postID string) {
    post := GetPost(db, postID)
    id := uuid.NewString()
    c := model.Comment{
        Content: content,
        ID:      id,
        Time:    time.Now().UTC().Format(time.Stamp),
        PostID:  postID,
    }
    post.Comments = append(post.Comments, c)
    if err := db.Save(&amp;post).Error; err != nil {
        return
    }
}

// GetComments returns the comments for the specified post
func GetComments(db *gorm.DB, postID string) []model.Comment {
    comments := []model.Comment{}
    
    // This will look in the database for comments with a matching PostID
    db.Find(&amp;comments, db.Where(model.Comment{PostID: postID}))
    return comments
}
</pre>

<p>
Okay, we&rsquo;re done with that file now. We&rsquo;re getting close! We can now finish setting up the route handlers in app/app.go.
</p>

<pre class="example" id="orgb94217d">
// Index handler
func (a *App) index(c gig.Context) error {
    // let's setup a string that will hold all of our gemtext
    buffer := ""
    
    // this is going to look pretty ugly, but it gets the job done
    buffer += "# Gemini Textboard\n"
    buffer += "\n"
    buffer += fmt.Sprintf("=&gt; %s %s\n", baseURL("/createpost"), "Create Post")
    buffer += "\n"
    buffer += "## Posts\n"
    buffer += "\n"
    
    // you see how handy those handlers are?
    for _, post := range handler.GetAllPosts(a.DB) {
        buffer += fmt.Sprintf("=&gt; %s %s\n", baseURL(fmt.Sprintf("/post/%s", post.ID)), post.ID)
        buffer += (post.Time + "\n")
        buffer += fmt.Sprintf("&gt; %s\n", post.Content)
        buffer += "\n"
    }
    
    // this sends the gemtext back to the client
    return c.Gemini(buffer)
}

// Post handler
func (a *App) post(c gig.Context) error {
    // this will get the post object for the this route
    post := handler.GetPost(a.DB, c.Param("id"))
    
    buffer := ""
    buffer += "# Post\n"
    buffer += fmt.Sprintf("=&gt; %s %s\n", baseURL("/"), "Home")
    buffer += "\n"
    buffer += (post.ID + "\n")
    buffer += (post.Time + " UTC\n")
    buffer += "\n"
    buffer += fmt.Sprintf("&gt; %s", post.Content)
    buffer += "\n"
    buffer += fmt.Sprintf("=&gt; %s %s\n", baseURL("/createcomment/"+post.ID), "Add Comment")
    buffer += "\n"
    buffer += "## Comments\n"
    buffer += "\n"
    
    for _, comment := range handler.GetComments(a.DB, post.ID) {
        buffer += (comment.ID + "\n")
        buffer += (comment.Time + " UTC\n")
        buffer += fmt.Sprintf("&gt; %s", comment.Content)
        buffer += "\n\n"
    }
    return c.Gemini(buffer)
}

// Create post handler
func (a *App) createPost(c gig.Context) error {
    // This will get the user input, if there is any
    q, err := c.QueryString()
    if err != nil {
        log.Fatal(err) // you should probably handle this differently in production, but this will do for now
    }
    
    if q == "" {
        return c.NoContent(gig.StatusInput, "Post Text")
    } else {
        id := handler.CreatePost(a.DB, q)
        return c.NoContent(gig.StatusRedirectTemporary, baseURL("/post/"+id))
    }
}

// Create comment handler
func (a *App) createComment(c gig.Context) error {
    q, err := c.QueryString()
	if err != nil {
		log.Fatal(err)
	}
	if q == "" {
		return c.NoContent(gig.StatusInput, "Add Comment")
	} else {
		post := handler.GetPost(a.DB, c.Param("id"))
		handler.AddComment(a.DB, q, post.ID)
		return c.NoContent(gig.StatusRedirectTemporary, baseURL("/post/"+post.ID))
	}
}
</pre>

<p>
Wow that was a mess. As an excersise, you should try making a library for generating gemtext. I made a simple one for my capsules, but it&rsquo;s not currently on GitHub. Sorry! Let&rsquo;s finish up app/app.go.
</p>

<pre class="example" id="org4b4b5c4">
func (a *App) Run(crt, key string) {
    log.Println("Server running at " + baseURL("/"))
    a.Router.Run(crt, key)
}
</pre>

<p>
Before we write the last of our code, we need to generate a self-signed certificate. The easiest way to get a self-signed certificate is to use Solderpunk&rsquo;s gemcert tool:
<a href="https://tildegit.org/solderpunk/gemcert">https://tildegit.org/solderpunk/gemcert</a>
</p>

<p>
You can also use openssl, but that&rsquo;s beyond the scope of this tutorial. Once you have your crt and key, put them in the root of your project. Done? Cool, let&rsquo;s write the last file, main.go.
</p>

<pre class="example" id="org9e9fb15">
package main

import (
    app "textboard/app"
)

func main() {
    app := &amp;app.App{}
    app.Init()
    
    // Fill this in with the correct crt and key names, in quotes
    app.Run("&lt;crt name&gt;", "&lt;key name&gt;")
}
</pre>

<p>
We&rsquo;re done! So much code! Now, let&rsquo;s build and run it.
</p>

<pre class="example" id="org53f7287">
go build
./textboard
</pre>

<p>
You should now be able to connect to gemini://localhost/ in your Gemini client of choice! If it doesn&rsquo;t compile, make sure you have all the requirements, and didn&rsquo;t type anything wrong. If you get a TLS error in your client, make sure you used the correct domain name when generating your certificate. It would be localhost for, well, localhost. Or your capsule&rsquo;s domain name if you have one.
</p>
</div>
</div>

<div id="outline-container-orgd1d5872" class="outline-2">
<h2 id="orgd1d5872">Conclusion</h2>
<div class="outline-text-2" id="text-orgd1d5872">
<p>
This was a pretty messy project, and it&rsquo;s not very useful, but it shows how interactive Gemini can really be. And maybe you learned a bit about Go along the way.
</p>

<p>
If you liked this post, feel free to check out my GitHub (it&rsquo;s pretty boring):
<a href="https://github.com/trebabcock">https://github.com/trebabcock</a>
</p>

<p>
Thanks for reading!
</p>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
